diff --git a/lib/hive/daemon/auto_retry/policy.rb b/lib/hive/daemon/auto_retry/policy.rb
new file mode 100644
index 00000000..0837e015
--- /dev/null
+++ b/lib/hive/daemon/auto_retry/policy.rb
@@ -0,0 +1,125 @@
+# frozen_string_literal: true
+
+module Hive
+  module Daemon
+    module AutoRetry
+      # Hardcoded conservative v1 policy constants and pure decision logic
+      # over durable state records.
+      module Policy
+        MAX_ATTEMPTS = 2
+        SECOND_ATTEMPT_BACKOFF_SEC = 30 * 60
+        FALLBACK_REPROBE_SEC = 30 * 60
+        NEGATIVE_DECISION_THROTTLE_SEC = 30 * 60
+        MAX_UNIQUE_PROBES_PER_TICK = 2
+
+        module_function
+
+        Decision = Struct.new(
+          :action, :rationale, :eligible_at, :attempt_number,
+          keyword_init: true
+        )
+
+        # Decide whether a probe/retry may proceed for a state record given
+        # a newly observed healthy fingerprint (or nil when not yet probed).
+        #
+        # @param record [Hash] durable state record
+        # @param healthy_fingerprint [String, nil]
+        # @param now [Time]
+        def decide(record:, healthy_fingerprint: nil, now: Time.now)
+          record = stringify(record)
+          attempts = record["attempts_dispatched"].to_i
+          phase = record["phase"].to_s
+
+          if phase == "exhausted" || attempts >= MAX_ATTEMPTS
+            return Decision.new(action: :refuse, rationale: "exhausted",
+                                eligible_at: nil, attempt_number: attempts)
+          end
+
+          if %w[clear_queued marker_cleared retry_queued retry_dispatched].include?(phase)
+            return Decision.new(action: :reconcile, rationale: "in_flight_#{phase}",
+                                eligible_at: nil, attempt_number: attempts + 1)
+          end
+
+          if healthy_fingerprint.nil? || healthy_fingerprint.to_s.empty?
+            return Decision.new(action: :probe, rationale: "need_health_probe",
+                                eligible_at: now, attempt_number: attempts + 1)
+          end
+
+          last_fp = record["last_attempted_fingerprint"].to_s
+          if attempts.zero?
+            # First retry: immediately eligible after first healthy signal.
+            if last_fp.empty? || last_fp != healthy_fingerprint.to_s ||
+               record["last_probe_healthy"] != true
+              return Decision.new(action: :retry, rationale: "first_healthy_signal",
+                                  eligible_at: now, attempt_number: 1)
+            end
+            # Same fingerprint already tried? Should not happen with attempts=0.
+            return Decision.new(action: :retry, rationale: "first_healthy_signal",
+                                eligible_at: now, attempt_number: 1)
+          end
+
+          # Attempt 2: fingerprint must differ from attempt 1 and remain the
+          # healthy candidate for 30 minutes, then pass a fresh probe.
+          if healthy_fingerprint.to_s == last_fp
+            return Decision.new(action: :refuse, rationale: "unchanged_fingerprint",
+                                eligible_at: nil, attempt_number: attempts + 1)
+          end
+
+          candidate_fp = record["second_candidate_fingerprint"].to_s
+          candidate_since = parse_time(record["second_candidate_first_seen_at"])
+          if candidate_fp != healthy_fingerprint.to_s || candidate_since.nil?
+            # New candidate window starts now; caller persists it.
+            eligible = now + SECOND_ATTEMPT_BACKOFF_SEC
+            return Decision.new(action: :wait, rationale: "second_attempt_backoff",
+                                eligible_at: eligible, attempt_number: 2)
+          end
+
+          eligible_at = candidate_since + SECOND_ATTEMPT_BACKOFF_SEC
+          if now < eligible_at
+            return Decision.new(action: :wait, rationale: "second_attempt_backoff",
+                                eligible_at: eligible_at, attempt_number: 2)
+          end
+
+          Decision.new(action: :retry, rationale: "second_attempt_ready",
+                       eligible_at: now, attempt_number: 2)
+        end
+
+        def should_reprobe?(record:, now: Time.now)
+          record = stringify(record)
+          last = parse_time(record["last_probe_at"])
+          return true if last.nil?
+
+          (now - last) >= FALLBACK_REPROBE_SEC
+        end
+
+        def should_emit_negative?(record:, signature:, now: Time.now)
+          record = stringify(record)
+          last_sig = record["last_negative_signature"].to_s
+          last_at = parse_time(record["last_negative_at"])
+          return true if last_sig != signature.to_s
+          return true if last_at.nil?
+
+          (now - last_at) >= NEGATIVE_DECISION_THROTTLE_SEC
+        end
+
+        def stringify(record)
+          return {} if record.nil?
+          return record.transform_keys(&:to_s) if record.is_a?(Hash)
+
+          {}
+        end
+        private_class_method :stringify
+
+        def parse_time(value)
+          return value if value.is_a?(Time)
+          return nil if value.nil? || value.to_s.empty?
+
+          Time.parse(value.to_s)
+        rescue ArgumentError
+          nil
+        end
+        private_class_method :parse_time
+      end
+    end
+  end
+end
diff --git a/lib/hive/daemon/auto_retry/probe_runner.rb b/lib/hive/daemon/auto_retry/probe_runner.rb
new file mode 100644
index 00000000..1f696dd2
--- /dev/null
+++ b/lib/hive/daemon/auto_retry/probe_runner.rb
@@ -0,0 +1,229 @@
+# frozen_string_literal: true
+
+require "open3"
+require "hive/secret_patterns"
+require "hive/diagnostic_helpers"
+
+module Hive
+  module Daemon
+    module AutoRetry
+      # Bounded array-argv subprocess runner for auto-retry health probes.
+      # Uses a process group + monotonic deadline; on timeout TERM → grace →
+      # KILL the group. Captures stdout/stderr separately, caps excerpts,
+      # scrubs invalid UTF-8, and redacts secrets before returning.
+      class ProbeRunner
+        DEFAULT_STATUS_TIMEOUT_SEC = 10
+        DEFAULT_SMOKE_TIMEOUT_SEC = 30
+        DEFAULT_TERM_GRACE_SEC = 1.0
+        DEFAULT_EXCERPT_BYTES = 2_048
+
+        Result = Struct.new(
+          :ok, :exit_status, :timed_out, :signaled, :stdout, :stderr,
+          :duration_sec, :error, :argv, keyword_init: true
+        ) do
+          def healthy?
+            ok == true
+          end
+        end
+
+        def initialize(env: nil, excerpt_bytes: DEFAULT_EXCERPT_BYTES,
+                       term_grace_sec: DEFAULT_TERM_GRACE_SEC)
+          @env = env
+          @excerpt_bytes = excerpt_bytes
+          @term_grace_sec = term_grace_sec
+        end
+
+        # @param argv [Array<String>] command + args (no shell)
+        # @param timeout_sec [Numeric]
+        # @param chdir [String, nil]
+        # @param stdin_data [String, nil]
+        def run(argv, timeout_sec:, chdir: nil, stdin_data: nil)
+          argv = Array(argv).map(&:to_s)
+          if argv.empty? || argv.any?(&:empty?)
+            return Result.new(ok: false, error: "empty_argv", argv: argv,
+                              exit_status: nil, timed_out: false, signaled: false,
+                              stdout: "", stderr: "", duration_sec: 0.0)
+          end
+
+          start = Process.clock_gettime(Process::CLOCK_MONOTONIC)
+          out_r, out_w = IO.pipe
+          err_r, err_w = IO.pipe
+          pid = nil
+          out_thread = nil
+          err_thread = nil
+          in_thread = nil
+          in_r = nil
+          in_w = nil
+
+          spawn_opts = {
+            out: out_w,
+            err: err_w,
+            pgroup: true,
+            close_others: true
+          }
+          spawn_opts[:chdir] = chdir if chdir
+          if stdin_data
+            in_r, in_w = IO.pipe
+            spawn_opts[:in] = in_r
+          end
+
+          pid = if @env
+            Process.spawn(@env, *argv, spawn_opts)
+          else
+            Process.spawn(*argv, spawn_opts)
+          end
+          out_w.close
+          err_w.close
+          stdout = ""
+          stderr = ""
+          out_thread = capture_thread(out_r) { |captured| stdout = captured }
+          err_thread = capture_thread(err_r) { |captured| stderr = captured }
+          if stdin_data
+            in_r.close
+            in_thread = Thread.new do
+              begin
+                in_w.write(stdin_data.to_s)
+              rescue Errno::EPIPE, IOError
+                nil
+              ensure
+                in_w.close unless in_w.closed?
+              end
+            end
+          end
+
+          timed_out = false
+          status = nil
+          deadline = start + timeout_sec.to_f
+          loop do
+            captured = Process.wait2(pid, Process::WNOHANG)
+            if captured
+              status = captured.last
+              break
+            end
+            if Process.clock_gettime(Process::CLOCK_MONOTONIC) >= deadline
+              timed_out = true
+              status = terminate_group(pid)
+              break
+            end
+            sleep 0.02
+          end
+
+          in_thread&.join(0.5)
+          finish_capture(out_thread, out_r)
+          finish_capture(err_thread, err_r)
+          duration = Process.clock_gettime(Process::CLOCK_MONOTONIC) - start
+
+          exit_status = status&.exitstatus
+          signaled = status && !status.exited? && status.signaled?
+          ok = !timed_out && !signaled && status&.success?
+
+          Result.new(
+            ok: ok == true,
+            exit_status: exit_status,
+            timed_out: timed_out,
+            signaled: signaled == true,
+            stdout: stdout,
+            stderr: stderr,
+            duration_sec: duration.round(3),
+            error: timed_out ? "timeout" : (signaled ? "signaled" : (ok ? nil : "nonzero_exit")),
+            argv: argv
+          )
+        rescue Errno::ENOENT => e
+          Result.new(ok: false, error: "missing_executable", exit_status: nil,
+                     timed_out: false, signaled: false, stdout: "",
+                     stderr: redact(e.message), duration_sec: 0.0, argv: argv)
+        rescue StandardError => e
+          Result.new(ok: false, error: "#{e.class}: #{e.message}", exit_status: nil,
+                     timed_out: false, signaled: false, stdout: "",
+                     stderr: redact(e.message), duration_sec: 0.0, argv: argv)
+        ensure
+          [ out_r, out_w, err_r, err_w, in_r, in_w ].each { |io| close_quietly(io) }
+        end
+
+        private
+
+        def close_quietly(io)
+          io&.close unless io&.closed?
+        rescue StandardError
+          nil
+        end
+
+        def terminate_group(pid)
+          return nil unless pid
+
+          begin
+            Process.kill("-TERM", pid)
+          rescue Errno::ESRCH, Errno::EPERM
+            return wait_status(pid)
+          end
+          deadline = Process.clock_gettime(Process::CLOCK_MONOTONIC) + @term_grace_sec
+          loop do
+            begin
+              captured = Process.wait2(pid, Process::WNOHANG)
+              return captured.last if captured
+            rescue Errno::ECHILD
+              return nil
+            end
+            break if Process.clock_gettime(Process::CLOCK_MONOTONIC) >= deadline
+
+            sleep 0.05
+          end
+          begin
+            Process.kill("-KILL", pid)
+          rescue Errno::ESRCH, Errno::EPERM
+            nil
+          end
+          wait_status(pid)
+        end
+
+        def wait_status(pid)
+          Process.wait2(pid).last
+        rescue Errno::ECHILD
+          nil
+        end
+
+        def capture_thread(io, &block)
+          Thread.new { block.call(read_capped(io)) }.tap do |thread|
+            thread.report_on_exception = false
+          end
+        end
+
+        def finish_capture(thread, io)
+          return unless thread
+          return if thread.join(1)
+
+          io.close unless io.closed?
+          thread.join(0.2)
+          thread.kill if thread.alive?
+        rescue IOError
+          nil
+        end
+
+        def read_capped(io)
+          raw = +""
+          while raw.bytesize < @excerpt_bytes
+            chunk = io.read([ 512, @excerpt_bytes - raw.bytesize ].min)
+            break if chunk.nil? || chunk.empty?
+
+            raw << chunk
+          end
+          # Drain remainder without retaining
+          begin
+            while io.read(4096)
+              # discard
+            end
+          rescue StandardError
+            nil
+          end
+          redact(Hive::DiagnosticHelpers.utf8(raw))
+        rescue StandardError
+          ""
+        end
+
+        def redact(text)
+          Hive::SecretPatterns.redact(Hive::DiagnosticHelpers.utf8(text.to_s))
+        end
+      end
+    end
+  end
+end
diff --git a/lib/hive/daemon/auto_retry/safety.rb b/lib/hive/daemon/auto_retry/safety.rb
new file mode 100644
index 00000000..b3e3a6e8
--- /dev/null
+++ b/lib/hive/daemon/auto_retry/safety.rb
@@ -0,0 +1,241 @@
+# frozen_string_literal: true
+
+require "hive/brainstorm_parser"
+require "hive/daemon/auto_retry/probe_runner"
+require "hive/markers"
+require "hive/lock"
+require "hive/task"
+
+module Hive
+  module Daemon
+    module AutoRetry
+      # Fail-closed stage-specific replay-safety guards. Run before probes
+      # and again immediately before marker clear.
+      class Safety
+        Result = Struct.new(:safe, :rationale, keyword_init: true) do
+          def safe?
+            safe == true
+          end
+        end
+
+        GENERATED_MARKER_LINE = /\A\s*#{Hive::Markers::MARKER_RE.source}\s*\z/m.freeze
+
+        def initialize(controller: nil, enabled_projects: nil, legacy_projects: nil,
+                       runner: nil)
+          @controller = controller
+          @enabled_projects = enabled_projects
+          @legacy_projects = legacy_projects || {}
+          @runner = runner || ProbeRunner.new
+        end
+
+        # @param row [StatusConsumer::Row]
+        # @param observed_marker_id [String]
+        # @param observed_reason [String]
+        # @param re_read [Boolean] when true, re-read marker/task from disk
+        def check(row:, observed_marker_id:, observed_reason:, re_read: false)
+          project = row_get(row, :project).to_s
+          slug = row_get(row, :slug).to_s
+          stage = row_get(row, :stage).to_s
+          folder = row_get(row, :folder).to_s
+
+          if @enabled_projects && @enabled_projects[project] == false
+            return unsafe(:project_disabled)
+          end
+
+          if @legacy_projects[project] || (@legacy_projects.respond_to?(:[]) && @legacy_projects[project])
+            return unsafe(:legacy_layout)
+          end
+
+          if folder.empty? || !File.directory?(folder)
+            return unsafe(:missing_task_folder)
+          end
+
+          if @controller&.running_task?(project: project, slug: slug)
+            return unsafe(:controller_owned)
+          end
+
+          live_task_lock = if re_read
+            live_task_lock?(folder)
+          else
+            row_get(row, :live_task_lock) == true
+          end
+          lock_owned = row_get(row, :task_lock_owned) == true
+          if live_task_lock && !lock_owned
+            return unsafe(:live_task_lock)
+          end
+
+          # Merge-watcher owns finalize recovery for allowlisted reasons.
+          if stage == "8-finalize" # coding-scoped: finalize recovery belongs to merge watcher
+            return unsafe(:merge_watcher_owned)
+          end
+
+          unless %w[2-brainstorm 3-plan 4-execute].include?(stage) # coding-scoped: v1 replay proofs
+            return unsafe(:stage_not_supported)
+          end
+
+          marker_ok = verify_marker(row, observed_marker_id, observed_reason, re_read: re_read)
+          return marker_ok unless marker_ok.safe?
+
+          # coding-scoped (block): v1 stage-specific replay-safety policies
+          case stage
+          when "4-execute"
+            execute_safe?(row)
+          when "2-brainstorm"
+            brainstorm_safe?(row)
+          when "3-plan"
+            plan_safe?(row)
+          else
+            unsafe(:stage_not_supported)
+          end
+        rescue StandardError => e
+          unsafe(:"error_#{e.class.name}")
+        end
+
+        private
+
+        def verify_marker(row, observed_marker_id, observed_reason, re_read:)
+          state_file = row_get(row, :state_file).to_s
+          if re_read && !state_file.empty? && File.file?(state_file)
+            marker = Hive::Markers.current(state_file)
+            name = marker.none? ? "none" : marker.name.to_s
+            attrs = marker.none? ? {} : marker.attrs
+          else
+            name = row_get(row, :marker).to_s.downcase
+            attrs = row_get(row, :marker_attrs) || {}
+          end
+
+          if %w[execute_complete complete review_complete].include?(name)
+            return unsafe(:terminal_success)
+          end
+          unless name == "error"
+            return unsafe(:marker_changed)
+          end
+
+          reason = attrs["reason"] || attrs[:reason]
+          marker_id = attrs["marker_id"] || attrs[:marker_id]
+          if reason.to_s != observed_reason.to_s
+            return unsafe(:marker_reason_changed)
+          end
+          if !observed_marker_id.to_s.empty? && marker_id.to_s != observed_marker_id.to_s
+            return unsafe(:marker_id_changed)
+          end
+
+          Result.new(safe: true, rationale: "marker_ok")
+        end
+
+        def execute_safe?(row)
+          worktree = row_get(row, :worktree_path).to_s
+          if worktree.empty?
+            # Try task reconstruction
+            folder = row_get(row, :folder).to_s
+            begin
+              task = Hive::Task.new(folder)
+              worktree = task.worktree_path.to_s
+            rescue StandardError
+              return unsafe(:worktree_unresolved)
+            end
+          end
+
+          return unsafe(:worktree_missing) if worktree.empty? || !File.directory?(worktree)
+          return unsafe(:not_a_git_repo) unless File.directory?(File.join(worktree, ".git")) ||
+                                                 File.file?(File.join(worktree, ".git"))
+
+          result = @runner.run(
+            [ "git", "-C", worktree, "status", "--porcelain" ],
+            timeout_sec: ProbeRunner::DEFAULT_STATUS_TIMEOUT_SEC
+          )
+          return unsafe(result.timed_out ? :git_status_timeout : :git_status_failed) unless result.healthy?
+          return unsafe(:dirty_worktree) unless result.stdout.to_s.empty?
+
+          Result.new(safe: true, rationale: "execute_clean")
+        rescue StandardError
+          unsafe(:execute_check_error)
+        end
+
+        def brainstorm_safe?(row)
+          folder = row_get(row, :folder).to_s
+          path = File.join(folder, "brainstorm.md")
+          return Result.new(safe: true, rationale: "blank_artifact") unless File.file?(path)
+
+          text = File.read(path, encoding: "UTF-8").scrub
+          return Result.new(safe: true, rationale: "blank_artifact") if blank_or_marker_only?(text)
+
+          questions = Hive::BrainstormParser.parse_text(text)
+          if questions.any?(&:answered?)
+            return unsafe(:answered_questions)
+          end
+          # Malformed substantive content without parseable questions is unsafe
+          # if it looks like more than markers/blank.
+          if questions.empty? && text.strip.length > 0 && !blank_or_marker_only?(text)
+            # Parser returned nothing but file has prose — fail closed when it
+            # contains non-header substantive lines that aren't Q-structure.
+            return unsafe(:malformed_brainstorm) if substantive_non_qa?(text)
+          end
+
+          Result.new(safe: true, rationale: "brainstorm_unanswered")
+        rescue StandardError
+          unsafe(:brainstorm_check_error)
+        end
+
+        def plan_safe?(row)
+          folder = row_get(row, :folder).to_s
+          path = File.join(folder, "plan.md")
+          return Result.new(safe: true, rationale: "blank_artifact") unless File.file?(path)
+
+          text = File.read(path, encoding: "UTF-8").scrub
+          # Strip only Hive-generated marker comments. Arbitrary HTML comments
+          # may be user feedback and therefore make replay unsafe.
+          cleaned = text.each_line.reject { |line| generated_marker_line?(line) }.join
+          return Result.new(safe: true, rationale: "blank_or_marker_only") if cleaned.strip.empty?
+
+          unsafe(:plan_has_content)
+        rescue StandardError
+          unsafe(:plan_check_error)
+        end
+
+        def blank_or_marker_only?(text)
+          text.each_line.all? do |line|
+            stripped = line.strip
+            stripped.empty? || generated_marker_line?(line)
+          end
+        end
+
+        def substantive_non_qa?(text)
+          text.each_line.any? do |line|
+            stripped = line.strip
+            next false if stripped.empty?
+            next false if generated_marker_line?(line)
+            next false if stripped.match?(/\A\#{1,3}\s/)
+
+            true
+          end
+        end
+
+        def row_get(row, key)
+          if row.respond_to?(key)
+            row.public_send(key)
+          elsif row.is_a?(Hash)
+            row[key] || row[key.to_s]
+          end
+        end
+
+        def generated_marker_line?(line)
+          line.to_s.match?(GENERATED_MARKER_LINE)
+        end
+
+        def live_task_lock?(folder)
+          lock_path = File.join(folder, ".lock")
+          return false unless File.exist?(lock_path)
+
+          !Hive::Lock.stale_lock?(lock_path)
+        rescue StandardError
+          true
+        end
+
+        def unsafe(rationale)
+          Result.new(safe: false, rationale: rationale.to_s)
+        end
+      end
+    end
+  end
+end
